﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinSchedule;
using System.Threading;
using Infragistics.Win;
using Infragistics.Win.UltraWinSchedule.TimelineView;
using System.Diagnostics;

namespace _82474
{
    public partial class Form1 : Form, IUIElementCreationFilter
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
           
            ultraTimelineView1.CreationFilter = this;
            SetAppointments(ultraCalendarInfo1.Owners["{unassigned_owner}"]);
        }

        private void SetAppointments(Infragistics.Win.UltraWinSchedule.Owner owner)
        {
            Random rnd = new Random();
            int apps = 10;//rnd.Next(3, 15);
            DateTime sDate = DateTime.Now.AddMinutes(rnd.Next(0, 15));
            Thread.Sleep(10);
            DateTime eDate = DateTime.Now.AddMinutes(rnd.Next(20, 100));
            for (int i = 0; i < apps; i++)
            {
                Appointment app = new Appointment(sDate, eDate);
                app.Description = string.Format("{0} App {1}", owner.Name, i);
                app.Subject = string.Format("{0} App {1}", owner.Name, i);
                app.Owner = owner;
                ultraCalendarInfo1.Appointments.Add(app);
                Thread.Sleep(10);
                int hoffset = rnd.Next(1, 20);
                sDate = sDate.AddHours(hoffset);
                eDate = sDate.AddMinutes(rnd.Next(20, 100));
            }
        }


        #region IUIElementCreationFilter Members

        static Dictionary<DateTime, TimeSlotUIElement> timeslots = new Dictionary<DateTime, TimeSlotUIElement>();
        static double workingHoursCalc = 8.00;
        static double startDay = 8.00;// in hours
        static  int br = 0;
        public void AfterCreateChildElements(UIElement parent)
        {

            Appointment appointment = null;

            if (parent is ActivityAreaUIElement)
            {
                timeslots.Clear();
                parent.ChildElements.Where(UI => UI is TimeSlotUIElement).ToList<UIElement>().ForEach(
                        delegate(UIElement ts)
                        {
                            if (!timeslots.ContainsKey(((TimeSlotUIElement)ts).DateTimeRange.StartDateTime))
                                timeslots.Add(((TimeSlotUIElement)ts).DateTimeRange.StartDateTime, ((TimeSlotUIElement)ts));
                        });
                Debug.WriteLine(br++);
            }

            if (parent is Infragistics.Win.UltraWinSchedule.TimelineView.AppointmentUIElement && ultraTimelineView1.PrimaryInterval is DateInterval)
            {

                int dayWidth = ultraTimelineView1.ColumnWidthResolved - 5;

                if (parent.Rect.Width < dayWidth)//less than a day.
                {
                    appointment = ((Infragistics.Win.UltraWinSchedule.TimelineView.AppointmentUIElement)parent).Appointment;

                    startDay = ultraCalendarInfo1.LogicalDayOffset.TotalHours;
                    double workingHours = ultraCalendarInfo1.LogicalDayDuration.TotalHours;
                    double forhold = appointment.EndDateTime.Subtract(appointment.StartDateTime).TotalHours / workingHoursCalc;

                    if (timeslots.ContainsKey(appointment.StartDateTime.Date))
                    {

                        var ts = timeslots[appointment.StartDateTime.Date];
                        int newStart = ts.RectInsideBorders.X;
                        double pixelPrHour = ts.RectInsideBorders.Width / workingHoursCalc;
                        int newOffset = Math.Max((int)((appointment.StartDateTime.TimeOfDay.TotalHours - startDay) * pixelPrHour), 0);
                        int newX = newStart + newOffset;
                        int newWidth = (int)(appointment.Span.TotalHours * pixelPrHour);

                        if (newWidth > ts.RectInsideBorders.Width)
                        {
                            newWidth = ts.RectInsideBorders.Width;
                        }

                        else if (newX + newWidth > ts.RectInsideBorders.X + ts.RectInsideBorders.Width)
                        {
                            newX = ts.RectInsideBorders.X + ts.RectInsideBorders.Width - newWidth;
                        }

                        parent.Rect = new Rectangle(newX, parent.Rect.Y, newWidth, parent.Rect.Height);
                    }

                }

            }


        }

        //public void AfterCreateChildElements(UIElement parent)
        //{

        //    Appointment appointment = null;


        //    if (parent is Infragistics.Win.UltraWinSchedule.TimelineView.AppointmentUIElement)
        //    {

        //        var appUI = (Infragistics.Win.UltraWinSchedule.TimelineView.AppointmentUIElement)parent;


        //        appointment = appUI.Appointment;


        //        if (ultraTimelineView1.PrimaryInterval is DateInterval)
        //        {

        //            int dayWidth = ultraTimelineView1.ColumnWidthResolved - 5;

        //            if (parent.Rect.Width < dayWidth)//less than a day.
        //            {

        //                Dictionary<DateTime, TimeSlotUIElement> timeslots = new Dictionary<DateTime, TimeSlotUIElement>();

        //                foreach (var child in parent.Parent.ChildElements)
        //                {

        //                    if (child is TimeSlotUIElement)
        //                    {

        //                        TimeSlotUIElement ts = (TimeSlotUIElement)child;


        //                        if (!timeslots.ContainsKey(ts.DateTimeRange.StartDateTime))
        //                        {

        //                            timeslots.Add(ts.DateTimeRange.StartDateTime, ts);

        //                        }

        //                    }

        //                }
        //                Debug.WriteLine(br++);


        //                double workingHoursCalc = 8.00;

        //                double startDay = 8.00;// in hours


        //                startDay = ultraCalendarInfo1.LogicalDayOffset.TotalHours;

        //                double workingHours = ultraCalendarInfo1.LogicalDayDuration.TotalHours;



        //                double forhold = appointment.EndDateTime.Subtract(appointment.StartDateTime).TotalHours / workingHoursCalc;


        //                if (timeslots.ContainsKey(appointment.StartDateTime.Date))
        //                {

        //                    var ts = timeslots[appointment.StartDateTime.Date];


        //                    int newStart = ts.RectInsideBorders.X;



        //                    double pixelPrHour = ts.RectInsideBorders.Width / workingHoursCalc;


        //                    int newOffset = (int)((appointment.StartDateTime.TimeOfDay.TotalHours - startDay) * pixelPrHour);

        //                    if (newOffset < 0)
        //                    {

        //                        newOffset = 0;

        //                    }

        //                    int newX = newStart + newOffset;


        //                    int newWidth = (int)(appointment.EndDateTime.Subtract(appointment.StartDateTime).TotalHours * pixelPrHour);

        //                    int newWidth2 = (int)(ts.RectInsideBorders.Width * forhold);

        //                    if (newWidth > ts.RectInsideBorders.Width)
        //                    {

        //                        newWidth = ts.RectInsideBorders.Width;

        //                    }

        //                    else if (newX + newWidth > ts.RectInsideBorders.X + ts.RectInsideBorders.Width)
        //                    {

        //                        newX = ts.RectInsideBorders.X + ts.RectInsideBorders.Width - newWidth;

        //                    }


        //                    parent.Rect = new Rectangle(newX, parent.Rect.Y, newWidth, parent.Rect.Height);


        //                }

        //            }

        //        }

        //    }

        //}


        public bool BeforeCreateChildElements(UIElement parent)
        {
            return false;
        }

        #endregion
    }
}
